#include "Token.h"
#include "Grammar.h"

#include <iostream>

int main(int argc, char** argv) {
	
	/*** Exercice 1 - Première grammaire
	
	
	Token* tS = new Token("S", false);
	Token* tB = new Token("B", false);
	Token* tD = new Token("D", false);
	Token* tE = new Token("E", false);
	Token* tF = new Token("F", false);
	Token* tu = new Token("u",true);
	Token* tv = new Token("v",true);
	Token* tw = new Token("w",true);
	Token* tx = new Token("x",true);
	Token* ty = new Token("y",true);
	Token* tz = new Token("z",true);
	Token* tepsilon = new Token();
	
	multimap<Token*, vector<Token*> > rules;
	Token* rule1Temp[] = {tu, tB, tD, tz};
	vector<Token*> rule1;
	rule1.assign (rule1Temp,rule1Temp+4);
	rules.insert(pair<Token*, vector<Token*> >(tS,rule1));
	
	vector<Token*> rule2;
	rule2.push_back(tB);
	rule2.push_back(tv);
	rules.insert(pair<Token*, vector<Token*> >(tB,rule2));
	
	vector<Token*> rule3;
	rule3.push_back(tw);
	rules.insert(pair<Token*, vector<Token*> >(tB,rule3));
	
	vector<Token*> rule4;
	rule4.push_back(tE);
	rule4.push_back(tF);
	rules.insert(pair<Token*, vector<Token*> >(tD,rule4));
	
	vector<Token*> rule5;
	rule5.push_back(ty);
	rules.insert(pair<Token*, vector<Token*> >(tE,rule5));
	
	vector<Token*> rule6;
	rule6.push_back(tepsilon);
	rules.insert(pair<Token*, vector<Token*> >(tE,rule6));
	
	vector<Token*> rule7;
	rule7.push_back(tx);
	rules.insert(pair<Token*, vector<Token*> >(tF,rule7));
	
	vector<Token*> rule8;
	rule8.push_back(tepsilon);
	rules.insert(pair<Token*, vector<Token*> >(tF,rule8));
	
	Grammar* gr = new Grammar(rules, tS);
	cout << (*gr);
	
	
	// Calcul de First et Follow
	gr->fst_follow();
	cout << "* Nullable (size: " << gr->nullable.size() << ") = " << endl;
	cout << gr->nullable << endl;
	cout << "* First (size: " << gr->first.size() << ") = " << endl;
	cout << gr->first << endl;
	cout << "* Follow (size: " << gr->follow.size() << ") = " << endl;
	cout << gr->follow << endl;
	
	
	// Calcul du directeur
	map<pair<Token*, vector<Token*> >, set<Token*> > direct_Gr = gr->director();
	cout << direct_Gr << endl;
	//*/
	
	//*** Exercice 1 - seconde grammaire
	Token* tS = new Token("S", false);
	Token* tB = new Token("B", false);
	Token* tD = new Token("D", false);
	Token* tE = new Token("E", false);
	Token* tF = new Token("F", false);
	Token* tu = new Token("u",true);
	Token* tv = new Token("v",true);
	Token* tw = new Token("w",true);
	Token* tx = new Token("x",true);
	Token* ty = new Token("y",true);
	Token* tz = new Token("z",true);
	Token* tepsilon = new Token();
	
	multimap<Token*, vector<Token*> > rules;
	Token* rule1Temp[] = {tu, tB, tD, tz};
	vector<Token*> rule1;
	rule1.assign (rule1Temp,rule1Temp+4);
	rules.insert(pair<Token*, vector<Token*> >(tS,rule1));
	
	vector<Token*> rule2;
	rule2.push_back(tv);
	rule2.push_back(tB);
	rules.insert(pair<Token*, vector<Token*> >(tB,rule2));
	
	vector<Token*> rule3;
	rule3.push_back(tw);
	rules.insert(pair<Token*, vector<Token*> >(tB,rule3));
	
	vector<Token*> rule4;
	rule4.push_back(tE);
	rule4.push_back(tF);
	rules.insert(pair<Token*, vector<Token*> >(tD,rule4));
	
	vector<Token*> rule5;
	rule5.push_back(ty);
	rules.insert(pair<Token*, vector<Token*> >(tE,rule5));
	
	vector<Token*> rule6;
	rule6.push_back(tepsilon);
	rules.insert(pair<Token*, vector<Token*> >(tE,rule6));
	
	vector<Token*> rule7;
	rule7.push_back(tx);
	rules.insert(pair<Token*, vector<Token*> >(tF,rule7));
	
	vector<Token*> rule8;
	rule8.push_back(tepsilon);
	rules.insert(pair<Token*, vector<Token*> >(tF,rule8));
	
	Grammar* gr = new Grammar(rules, tS);
	cout << (*gr);
	
	
	// Calcul de First et Follow
	gr->fst_follow();
	cout << "* Nullable (size: " << gr->nullable.size() << ") = " << endl;
	cout << gr->nullable << endl;
	cout << "* First (size: " << gr->first.size() << ") = " << endl;
	cout << gr->first << endl;
	cout << "* Follow (size: " << gr->follow.size() << ") = " << endl;
	cout << gr->follow << endl;
	
	
	// Calcul du directeur
	map<pair<Token*, vector<Token*> >, set<Token*> > direct_Gr = gr->director();
	cout << direct_Gr << endl;
	
	// Calcul de la table
	map<Token*, map<Token*, pair<Token*, vector<Token*> > > > table = gr->tableAnalysePred(direct_Gr);
	cout << table << endl;
	
	
	//*/
	
	
	return 0;
}


